net.sourceforge.pmd.lang.ecmascript.rule

## Class AbstractEcmascriptRule

- java.lang.Object
- - net.sourceforge.pmd.AbstractPropertySource
  - - net.sourceforge.pmd.lang.rule.AbstractRule
    - - net.sourceforge.pmd.lang.ecmascript.rule.AbstractEcmascriptRule

All Implemented Interfaces:
  EcmascriptParserVisitor, ImmutableLanguage, PropertySource, Rule

Direct Known Subclasses:
  ConsistentReturnRule

    public abstract class AbstractEcmascriptRule
    extends AbstractRule
    implements EcmascriptParserVisitor, ImmutableLanguage

### Field Summary

### Fields inherited from class net.sourceforge.pmd.AbstractPropertySource

`propertyDescriptors, propertyValuesByDescriptor`

### Fields inherited from interface net.sourceforge.pmd.Rule

`VIOLATION_SUPPRESS_REGEX_DESCRIPTOR, VIOLATION_SUPPRESS_XPATH_DESCRIPTOR`

### Constructor Summary

Constructors
Constructor and Description
`AbstractEcmascriptRule()`

### Method Summary

Methods
`void` `apply(List<? extends Node> nodes, RuleContext ctx)` Apply this rule to the given collection of nodes, using the given context.
`ParserOptions` `getParserOptions()` This implementation returns a new instance of `ParserOptions` using default settings.
`Object` `visit(ASTArrayComprehensionLoop node, Object data)`
`Object` `visit(ASTArrayComprehension node, Object data)`
`Object` `visit(ASTArrayLiteral node, Object data)`
`Object` `visit(ASTAssignment node, Object data)`
`Object` `visit(ASTAstRoot node, Object data)`
`Object` `visit(ASTBlock node, Object data)`
`Object` `visit(ASTBreakStatement node, Object data)`
`Object` `visit(ASTCatchClause node, Object data)`
`Object` `visit(ASTComment node, Object data)`
`Object` `visit(ASTConditionalExpression node, Object data)`
`Object` `visit(ASTContinueStatement node, Object data)`
`Object` `visit(ASTDoLoop node, Object data)`
`Object` `visit(ASTElementGet node, Object data)`
`Object` `visit(ASTEmptyExpression node, Object data)`
`Object` `visit(ASTExpressionStatement node, Object data)`
`Object` `visit(ASTForInLoop node, Object data)`
`Object` `visit(ASTForLoop node, Object data)`
`Object` `visit(ASTFunctionCall node, Object data)`
`Object` `visit(ASTFunctionNode node, Object data)`
`Object` `visit(ASTIfStatement node, Object data)`
`Object` `visit(ASTInfixExpression node, Object data)`
`Object` `visit(ASTKeywordLiteral node, Object data)`
`Object` `visit(ASTLabeledStatement node, Object data)`
`Object` `visit(ASTLabel node, Object data)`
`Object` `visit(ASTLetNode node, Object data)`
`Object` `visit(ASTName node, Object data)`
`Object` `visit(ASTNewExpression node, Object data)`
`Object` `visit(ASTNumberLiteral node, Object data)`
`Object` `visit(ASTObjectLiteral node, Object data)`
`Object` `visit(ASTObjectProperty node, Object data)`
`Object` `visit(ASTParenthesizedExpression node, Object data)`
`Object` `visit(ASTPropertyGet node, Object data)`
`Object` `visit(ASTRegExpLiteral node, Object data)`
`Object` `visit(ASTReturnStatement node, Object data)`
`Object` `visit(ASTScope node, Object data)`
`Object` `visit(ASTStringLiteral node, Object data)`
`Object` `visit(ASTSwitchCase node, Object data)`
`Object` `visit(ASTSwitchStatement node, Object data)`
`Object` `visit(ASTThrowStatement node, Object data)`
`Object` `visit(ASTTryStatement node, Object data)`
`Object` `visit(ASTUnaryExpression node, Object data)`
`Object` `visit(ASTVariableDeclaration node, Object data)`
`Object` `visit(ASTVariableInitializer node, Object data)`
`Object` `visit(ASTWhileLoop node, Object data)`
`Object` `visit(ASTWithStatement node, Object data)`
`Object` `visit(ASTXmlDotQuery node, Object data)`
`Object` `visit(ASTXmlExpression node, Object data)`
`Object` `visit(ASTXmlMemberGet node, Object data)`
`Object` `visit(ASTXmlString node, Object data)`
`Object` `visit(EcmascriptNode node, Object data)`
`protected void` `visitAll(List<? extends Node> nodes, RuleContext ctx)`

### Methods inherited from class net.sourceforge.pmd.lang.rule.AbstractRule

`addExample, addRuleChainVisit, addRuleChainVisit, addViolation, addViolation, addViolation, addViolationWithMessage, addViolationWithMessage, addViolationWithMessage, deepCopyValuesTo, end, equals, getDescription, getExamples, getExternalInfoUrl, getLanguage, getMaximumLanguageVersion, getMessage, getMinimumLanguageVersion, getName, getPriority, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, hashCode, isDeprecated, setDeprecated, setDescription, setExternalInfoUrl, setLanguage, setMaximumLanguageVersion, setMessage, setMinimumLanguageVersion, setName, setPriority, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

### Methods inherited from class net.sourceforge.pmd.AbstractPropertySource

`copyPropertyDescriptors, copyPropertyValues, definePropertyDescriptor, dysfunctionReason, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.sourceforge.pmd.PropertySource

`definePropertyDescriptor, dysfunctionReason, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Constructor Detail

#### AbstractEcmascriptRule

    public AbstractEcmascriptRule()

### Method Detail

#### getParserOptions

    public ParserOptions getParserOptions()

Description copied from class: `AbstractRule`
This implementation returns a new instance of `ParserOptions` using default settings.

Specified by:
  `getParserOptions` in interface `Rule`
Overrides:
  `getParserOptions` in class `AbstractRule`
See Also:
  `Rule.setPriority(RulePriority)`

#### apply

    public void apply(List<? extends Node> nodes,
             RuleContext ctx)

Description copied from interface: `Rule`
Apply this rule to the given collection of nodes, using the given context.

Specified by:
  `apply` in interface `Rule`

#### visitAll

    protected void visitAll(List<? extends Node> nodes,
                RuleContext ctx)

#### visit

    public Object visit(EcmascriptNode node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTArrayComprehension node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTArrayComprehensionLoop node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTArrayLiteral node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTAssignment node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTAstRoot node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTBlock node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTBreakStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTCatchClause node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTComment node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTConditionalExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTContinueStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTDoLoop node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTElementGet node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTEmptyExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTExpressionStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTForInLoop node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTForLoop node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTFunctionCall node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTFunctionNode node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTIfStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTInfixExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTKeywordLiteral node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTLabel node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTLabeledStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTLetNode node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTName node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTNewExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTNumberLiteral node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTObjectLiteral node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTObjectProperty node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTParenthesizedExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTPropertyGet node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTRegExpLiteral node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTReturnStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTScope node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTStringLiteral node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTSwitchCase node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTSwitchStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTThrowStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTTryStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTUnaryExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTVariableDeclaration node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTVariableInitializer node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTWhileLoop node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTWithStatement node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTXmlDotQuery node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTXmlExpression node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTXmlMemberGet node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`

#### visit

    public Object visit(ASTXmlString node,
               Object data)

Specified by:
  `visit` in interface `EcmascriptParserVisitor`